function similarity = compare_spatiograms(spat1, spat2)

global just_do_histogram

invvar_r = 1./spat1.var_r + 1./spat2.var_r;
invvar_c = 1./spat1.var_c + 1./spat2.var_c;
mahalan_r = (spat1.mean_r-spat2.mean_r).^2 .* invvar_r;
mahalan_c = (spat1.mean_c-spat2.mean_c).^2 .* invvar_c;

weights = exp(-0.5 .*  (mahalan_r + mahalan_c));
% covinv = covinv1 + covinv2;
% weights = exp(-0.5 * (spat_mean1' * covinv * spatmean2));
psi = sqrt(spat1.histogram .* spat2.histogram);
if just_do_histogram,
    similarity = sum(sum(sum(psi)));
else
    similarity = sum(sum(sum(weights .* psi)));
end