function inbounds = is_state_in_bounds(state, aspect_ratio, img_sz)

axis_horiz = state(3);
axis_vert = round(state(3)*aspect_ratio);
r0 = state(1) - axis_vert;
r1 = state(1) + axis_vert;
c0 = state(2) - axis_horiz;
c1 = state(2) + axis_horiz;
border = 1;
if (r0>=1+border & r1<img_sz(1)-border) ...
        & (c0>=1+border & c1<img_sz(2)-border),
    inbounds = 1;
else
    inbounds = 0;
end