clear 
close all;
load 'spatioxandyfinal';
f = 0;
aspect_ratio = 1.2;
fname_base ='c:/research/images/noellipse/seq_sb/img%03d.bmp';
%fname_base ='c:/stb/data/images/headtracker/seq_sb/img%03d.bmp';
%fname_out ='img%03d.ppm';
%fname_base = 'c:/research/images/noellipse/seq_sri/image%03d.ppm';
%fname_train = 'c:/research/images/noellipse/seq_sri_train/img%03d.ppm';
nbins = [8 8 4];
nframes = 100;
%showimg = [];
%fname_base = 'c:/research/images/Football/f_%03d.ppm';


% <-------sriram's sequence------>
% img1 = double(imread(sprintf(fname_train,1)));
%  state_in1 = [66 70 24]; 
% 
% img2 = double(imread(sprintf(fname_train,2)));
%  state_in2 = [60 46 21];
% 
% img3 = double(imread(sprintf(fname_train,3)));
%  state_in3 = [70 68 24];
% 
% img4 = double(imread(sprintf(fname_train,4)));
% state_in4 = [78 67 19];

%<-----------seq_sb----->
% img2 = double(imread(sprintf(fname_base,17)));
% %imagesc(img1(:,:,1));
% %[state_in(1), state_in(2)] = ginput(1)
%  state_in1 = [65 55 10]; 
%  
% 
% img1 = double(imread(sprintf(fname_base,25)));
%  state_in2 = [65 56 14];
%  %imagesc(img2(:,:,1));
% %[state_in(1), state_in(2)] = ginput(1)
% 
% img3 = double(imread(sprintf(fname_base,32)));
%  state_in3 = [67 49 15];
% 
% img4 = double(imread(sprintf(fname_base,45)));
% state_in4 = [42 57 19];
img1 = double(imread(sprintf(fname_base,25)));
state_in1 = [65 56 14];
img2 = double(imread(sprintf(fname_base,32)));
state_in2 = [67 49 15];
img3 = double(imread(sprintf(fname_base,45)));
state_in3 = [42 57 19];
img4 = double(imread(sprintf(fname_base,17)));
state_in4 = [65 55 10];

cimg1 = colspace(img1,1);
cimg2 = colspace(img2,1);
cimg3 = colspace(img3,1);
cimg4 = colspace(img4,1);


spat1 = compute_color_spatiogram(cimg1, state_in1, aspect_ratio,nbins);
spat2 = compute_color_spatiogram(cimg2, state_in2, aspect_ratio,nbins);
spat3 = compute_color_spatiogram(cimg3, state_in3, aspect_ratio,nbins);
spat4 = compute_color_spatiogram(cimg4, state_in4, aspect_ratio,nbins);

for f =50:421,
    %f = 396;
    % close all;
    % figuretmp = figure;
    % figure(1);
    img = double(imread(sprintf(fname_base,f)));
    img_color = colspace(img,1);
    state(1) = spat_ypts(f);
    state(2) = spat_xpts(f);
    state(3) = spat_scal(f);
    %spatiogram = compute_color_spatiogram(img, state_in, aspect_ratio,nbins);
    [orient, angle] = find_spatiogram_orientation(img_color,state,aspect_ratio,nbins,spat1,spat2,spat3,spat4);
    % img_orient = showimg(orient);
    if orient == 1
        img_orient = img1;
    else
        if orient == 2
            img_orient = img2;
        else
            if orient == 3
                img_orient = img3;
            else
                img_orient = img4;
            end
        end
    end
    
    % display image
    clf, hold on
    axis('ij')
    axis([0 128 0 96])
    imagesc(rgb2gray(uint8(img)))
    colormap(gray)
    
    % display circle
    cen = [105 20];
    rad = 15;
    h = rectangle('curvature', [1 1], 'position', [cen-rad 2*rad*[1 1]]);
    set(h, 'edgecolor', 'k')
    set(h, 'facecolor', 'w')
    set(h, 'linewidth', 4)
    
    % display line
    angle
    angle = 180 - angle;
    h = line([cen(1) cen(1) + rad*cos(pi/180*angle)], [cen(2) cen(2) - rad*sin(pi/180*angle)]);
    set(h, 'color', 'k')
    set(h, 'linewidth', 4)
    
    % display inset
    imagesc(128-51 + (1:51), 96-38 + (1:38), rgb2gray(uint8(img_orient(20:80,20:100,:))))
    
    if 0,  % sriram's way
        % close all;
        % figuretmp=figure;
        %    figure(1);
        img_orient = uint8(img_orient);
        subplot(2,1,1)
        imagesc(uint8(img));
        ell = ellipse(state,aspect_ratio);
        hold on;
        h = plot(ell(1,:),ell(2,:));
        set(h,'linewidth',2);
        axis equal;
        axis off;
        hold off;
        
        subplot(2,1,2)
        imagesc(img_orient);
        axis equal;
        axis off;
        %subplot(2,2,3)
        % saveas(figuretmp,sprintf(fname_out,f));
        %pause(0.5)
    end
    waitforbuttonpress;
%pause(0.1)
end
