function likelihood_grad = compute_likelihood_gradmag(img, state, search_range, aspect_ratio, gradmag_thresh);
likelihood_grad = zeros(search_range(1),search_range(2));
prewittker = [-1 0 1];
gray_imgn = img(:,:,1);
gradn_x = conv2(gray_imgn,prewittker,'same');
gradn_y = conv2(gray_imgn,prewittker','same');
gradn_magnitude = abs(gradn_x) + abs(gradn_y);
gradn_magnitude = min(gradn_magnitude, gradmag_thresh);
cntr = 1;
%for sc = (1-search_range(3)):0.1:(1+search_range(3))
for sc = state(3)-1:1:state(3) + 1
for m = state(1) - search_range(1) :state(1) +  search_range(1)
    for n = state(2) - search_range(2) :state(2) +  search_range(2)
        
            
            temp_state(1) = m;
            temp_state(2) = n;
          %  temp_state(3) = state(3)*sc;
          temp_state(3) = sc;
            ellipse_perimeter = ellipse(temp_state,aspect_ratio);
            sz = size(ellipse_perimeter);
            sumn = 0;
            for k = 1:sz(2)
                etmp1=ellipse_perimeter(1,k);
                etmp2=ellipse_perimeter(2,k);
                if (etmp1<=size(img,2))&&(etmp1>0)&&(etmp2<=size(img,1))&&(etmp2>0)
                    sumn = sumn + gradn_magnitude((ellipse_perimeter(2,k)),(ellipse_perimeter(1,k)));
                end
            end
             likelihood_grad(m-state(1) + search_range(1)+1,n-state(2)+search_range(2)+1,cntr) =abs( sumn);    
        end       
    end
    cntr = cntr + 1;
           
end
%szlike = size(likelihood_grad);
minn = min(min(min(likelihood_grad)));
maxx = max(max(max(likelihood_grad)));
likelihood_grad = (likelihood_grad - minn) / (maxx - minn);

% figure(2),colormap(gray);
% subplot(2,2,1)
% imagesc(likelihood_grad(:,:,1));
% subplot(2,2,2)
% imagesc(likelihood_grad(:,:,2));
% subplot(2,2,3)
% imagesc(likelihood_grad(:,:,3));
%waitforbuttonpress;