% track mug using mean shift
% (This is old code.  Use main_meanshift_spatiogram instead.)

initial_state = [62 55 22];  % initial state for mug_video1
%initial_state = [63 34 18];  % initial state for mug_video2
state = initial_state;
aspect_ratio = 1.4;
nbins = [8,8,8];
%fname_base = 'c:/stb/data/mugs/mugtest00_%02d.bmp';   % mugtest and mug_video1 share the same first frame
fname_base = 'c:/stb/data/mugs/mug_video1_frame_%04d.bmp';
%fname_base = 'c:/stb/data/mugs/mug_video2_frame_%04d.bmp';

frame_num = 0;
im = imread(sprintf(fname_base, frame_num));
im = double(im);
if 0,
    % user clicks on figure to initialize
	figure(1), clf, hold on, imagesc(uint8(im)); axis('ij')
	[state(2) state(1)] = ginput(1);
	state(3) = 18;
    show_ellipse_overlayed(im, state, aspect_ratio);
    pause(1)
end

% compute histogram of model
hist_model = compute_meanshift_histogram(im, state, aspect_ratio, nbins);

for frame_num=1:163,
    % load image
    im = imread(sprintf(fname_base, frame_num));
    im = double(im);
%    figure(2), imagesc(uint8(im))

    % track
    [shift, niter] = compute_meanshift_vector_repeat(hist_model, im, state, aspect_ratio, nbins);
    [shift, niter]
    state(1:2) = state(1:2) + shift;
    figure(2)
    show_ellipse_overlayed(im, state, aspect_ratio);
    pause(0.1)

    % get ready for next time
    hist_model = compute_meanshift_histogram(im, state, aspect_ratio, nbins);
end

    


